create table departments (creation_instant timestamp(6) with time zone not null, modification_instant timestamp(6) with time zone not null, department_acronym char(3) not null, faculty_acronym char(3) not null, name varchar(255) not null, primary key (department_acronym));
create table faculties (creation_instant timestamp(6) with time zone not null, modification_instant timestamp(6) with time zone not null, faculty_acronym char(3) not null, name varchar(255) not null, primary key (faculty_acronym));
create table project_documents (creation_instant timestamp(6) with time zone not null, modification_instant timestamp(6) with time zone not null, project_document_id uuid not null, project_id uuid not null, content varbinary(255) not null, title varchar(255) not null, primary key (project_document_id), constraint uk_project_documents unique (title));
create table projects (deadline date, grade numeric(2,1), supervising_tutor_1_accepted boolean not null, supervising_tutor_2_accepted boolean not null, creation_instant timestamp(6) with time zone not null, modification_instant timestamp(6) with time zone not null, project_id uuid not null, student_id uuid not null, supervising_tutor_1_id uuid not null, supervising_tutor_2_id uuid, department_acronym char(3) not null, faculty_acronym char(3) not null, project_type char(3) not null, status char(3) not null, student_signature varbinary(255) not null, supervising_tutor_1_signature varbinary(255), supervising_tutor_2_signature varbinary(255), title varchar(255) not null, primary key (project_id));
create table user_departments (user_id uuid not null, department_acronym char(3) not null);
create table user_faculties (user_id uuid not null, faculty_acronym char(3) not null);
create table users (admin boolean not null, faculty_board_of_examiners boolean not null, creation_instant timestamp(6) with time zone not null, modification_instant timestamp(6) with time zone not null, user_id uuid not null, password varchar(60) not null, email varchar(254) not null, user_type char(3) not null, primary key (user_id), constraint uk_users_email unique (email));
create index ix_projects_cre_instant on projects (creation_instant);
create index ix_projects_mod_instant on projects (modification_instant);
create index ix_projects_status on projects (status);
create index ix_users_type on users (user_type);
alter table if exists departments add constraint fk_departments_f_acronym foreign key (faculty_acronym) references faculties;
alter table if exists project_documents add constraint fk_projects_document_p_id foreign key (project_id) references projects;
alter table if exists projects add constraint fk_projects_d_acronym foreign key (department_acronym) references departments;
alter table if exists projects add constraint fk_projects_f_acronym foreign key (faculty_acronym) references faculties;
alter table if exists projects add constraint fk_projects_student_id foreign key (student_id) references users;
alter table if exists projects add constraint fk_projects_tutor_1_id foreign key (supervising_tutor_1_id) references users;
alter table if exists projects add constraint fk_projects_tutor_2_id foreign key (supervising_tutor_2_id) references users;
alter table if exists user_departments add constraint fk_user_departments_d_acr foreign key (department_acronym) references departments;
alter table if exists user_departments add constraint fk_user_departments_u_id foreign key (user_id) references users;
alter table if exists user_faculties add constraint fk_user_faculties_f_acr foreign key (faculty_acronym) references faculties;
alter table if exists user_faculties add constraint fk_user_faculties_u_id foreign key (user_id) references users;
insert into faculties (faculty_acronym, creation_instant, modification_instant, name) values ('GET', now(), now(), 'Gebäudetechnik und Informatik');
insert into departments (department_acronym,     creation_instant, modification_instant, name, faculty_acronym) values ('AI', now(), now(), 'Angewandte Informatik', 'GET');
insert into users (user_id, creation_instant, modification_instant, email, password,     user_type, admin, faculty_board_of_examiners) values ('612d3ea1-a0f0-f0a7-a7fc-775746569316', now(), now(),     'steffen.avemarg@fh-erfurt.de',     '2a$10$loNsdcdGqC7zkYg0bW7P6.zKpbui4RqyaLYHIMnPWAwZJQ.pbSmFW',     'LEC', true, true);
insert into user_faculties (user_id, faculty_acronym) values ('612d3ea1-a0f0-f0a7-a7fc-775746569316', 'GET');
insert into user_departments (user_id, department_acronym) values ('612d3ea1-a0f0-f0a7-a7fc-775746569316', 'AI');
insert into users (user_id, creation_instant, modification_instant, email, password,     user_type, admin, faculty_board_of_examiners) values ('6510b80d-5c6a-6a0c-0cce-775746567316', now(), now(),     'kay.guertzig@fh-erfurt.de',     '2a$10$loNsdcdGqC7zkYg0bW7P6.zKpbui4RqyaLYHIMnPWAwZJQ.pbSmFW',     'LEC', false, true);
insert into user_faculties (user_id, faculty_acronym) values ('6510b80d-5c6a-6a0c-0cce-775746567316', 'GET');
insert into user_departments (user_id, department_acronym) values ('6510b80d-5c6a-6a0c-0cce-775746567316', 'AI');
insert into users (user_id, creation_instant, modification_instant, email, password,     user_type, admin, faculty_board_of_examiners) values ('612bc797-83ef-efa7-a782-775746567316', now(), now(),     'stefan.woyde@fh-erfurt.de',     '2a$10$loNsdcdGqC7zkYg0bW7P6.zKpbui4RqyaLYHIMnPWAwZJQ.pbSmFW',     'STU', true, false);
insert into user_faculties (user_id, faculty_acronym) values ('612bc797-83ef-efa7-a782-775746567316', 'GET');
insert into user_departments (user_id, department_acronym) values ('612bc797-83ef-efa7-a782-775746567316', 'AI');
insert into projects (creation_instant, modification_instant,     title, project_type, status, project_id, faculty_acronym, department_acronym,     student_id, student_signature,     supervising_tutor_1_id, supervising_tutor_1_accepted, supervising_tutor_2_accepted) values (now(), now(),     'Test-BA-Projekt', 'BAP', 'SUB', '6510aab9-9108-08db-db56-775746567316', 'GET', 'AI',     '612bc797-83ef-efa7-a782-775746567316', ''::bytea,     '612d3ea1-a0f0-f0a7-a7fc-775746569316', false, false);
insert into projects (creation_instant, modification_instant,     title, project_type, status, project_id, faculty_acronym, department_acronym,     student_id, student_signature,     supervising_tutor_1_id, supervising_tutor_1_accepted,     supervising_tutor_2_id, supervising_tutor_2_accepted) values (now(), now(),     'Test-BA-Abschlussarbeit', 'BAT', 'SUB', '6510aaf1-9462-62a7-a770-775746567316', 'GET', 'AI',     '612bc797-83ef-efa7-a782-775746567316', ''::bytea,     '612d3ea1-a0f0-f0a7-a7fc-775746569316', false,     '6510b80d-5c6a-6a0c-0cce-775746567316', false);
